////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//      -You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////

var config = {
    width: 800,
    height: 600,
    type: Phaser.WEBGL,
    backgroundColor: '#000000',
    parent: 'game_screen',
    scene: {
        create: create,
        update: update
    }
};

var game = new Phaser.Game(config);

var dynText, dynText2, renderTexture, renderTexture2;

var phaser = undefined;

function create ()
{
    
	phaser = this;
	
	
	
        dynText = new DynamicText(this, game);
	dynText.visible = false;
	dynText.create('Dynamic Text', { fontFamily: 'Arial', fontSize: 40, color: '#ffffff' }, new DynamicTextConfig.Arial());
	
	//dynText.drawToTexture(renderTexture);
	
	renderTexture = this.add.renderTexture(dynText.x, dynText.y, dynText.computedWidth, dynText.fontSize);
	renderTexture.setOrigin(0.5, 0.5);
	
	dynText.setRenderTexture(renderTexture);
	
	console.log(dynText.computedWidth);
    
        animText1();
	
	
	dynText2 = new DynamicText(this, game);
	dynText2.visible = false;
	dynText2.originX = 0.5;
	dynText2.create('Dynamic Text', { fontFamily: 'Arial', fontSize: 40, color: '#ffffff' }, new DynamicTextConfig.Arial());
	
	renderTexture2 = this.add.renderTexture(dynText2.x, dynText2.y, dynText2.computedWidth, dynText2.fontSize + 80);
	renderTexture2.setOrigin(0.5, 0.5);
	dynText2.texPadV = 50;
	
	dynText2.setRenderTexture(renderTexture2);
    
        animText2();
	
	phaser.tweens.add({
		targets: renderTexture,
		rotation: Phaser.Math.DegToRad(360),
		ease: "Sine.easeInOut",
		duration: 5000,
		repeat: -1,
		yoyo: true
	});
	
	phaser.tweens.add({
		targets: renderTexture2,
		scaleX: 2,
		scaleY: 2,
		ease: "Sine.easeInOut",
		duration: 1000,
		repeat: -1,
		yoyo: true
	});
	
    
}

function update(){
	
	dynText.update();
	dynText2.update();
	

	
	//dynText2.drawToTexture(renderTexture);

}


function animText1(){
	
	var textThis = dynText;
	
	for(var i = 0; i < dynText.children.length; i++){
		
		var child = dynText.children[i];
		var gobj = child.gobj;
		gobject = gobj;
		
		gobj.setScale(1.05, 1.05);
		gobj.rotation = Phaser.Math.DegToRad(2);
		
		/*
		phaser.tweens.add({
			targets: gobj,
			scaleX: 1,
			scaleY: 1,
			rotation: Phaser.Math.DegToRad(-2),
			duration: 100,
			delay: i * 5,
			repeat: -1
		});
		*/
		
		phaser.tweens.add({
			targets: gobj,
			scaleX: 1,
			scaleY: 1,
			rotation: Phaser.Math.DegToRad(-360),
			duration: 5000,
			delay: i * 20,
			repeat: -1
		});
		
		var color = new Phaser.Display.Color();
		
		
		var timedEvent = phaser.time.addEvent({ delay: i * 10, callback: function(){
			
			var timedEvent2 = phaser.time.addEvent({ delay: 100, callback: function(){
				color.random(50);
				var randAlpha = Phaser.Math.Between(50, 100) / 100;
				//this.setColor(color.rgba);
				this.setAlpha(randAlpha);
			}, callbackScope: this, loop: true });
			
		}, callbackScope: gobj});
		
	}
	
	dynText.x = 100;
	
	phaser.tweens.add({
		targets: dynText,
		x: 300,
		ease: "Sine.easeInOut",
		duration: 2500,
		repeat: -1,
		yoyo: true
	});
	
	dynText.y = (game.canvas.height / 2) - 200;
	
	phaser.tweens.add({
		targets: dynText,
		y: (game.canvas.height / 2) + 200,
		ease: "Sine.easeInOut",
		duration: 5000,
		delay: 2500,
		repeat: -1,
		yoyo: true
	});
	
}

function animText2(){
	
	var textThis = dynText2;
	
	var curDText = dynText2;
	
	curDText.originX = 0.5;
	
	curDText.x = (game.canvas.width / 2);
	curDText.y = (game.canvas.height) - 50;
	
	
	for(var i = 0; i < curDText.children.length; i++){
		
		var child = curDText.children[i];
		var gobj = child.gobj;

		phaser.tweens.add({
			targets: child,
			offsetY: -10,
			duration: 200,
			delay: i * 50,
			ease: "Sine.easeInOut",
			repeat: -1,
			yoyo: true
		});
		
		var color = new Phaser.Display.Color();
		
		
		var timedEvent = phaser.time.addEvent({ delay: i * 10, callback: function(){
			
			var timedEvent2 = phaser.time.addEvent({ delay: 100, callback: function(){
				color.random(50);
				var randAlpha = Phaser.Math.Between(80, 100) / 100;
				this.setColor(color.rgba);
				//this.setAlpha(randAlpha);
			}, callbackScope: this, loop: true });
			
		}, callbackScope: gobj});
		
	}
	
	phaser.tweens.add({
		targets: curDText,
		charSpaceX: 15,
		ease: "Sine.easeInOut",
		duration: 2000,
		repeat: -1,
		yoyo: true
	});
	
}